/* Tabela TIPOOPEROPL: Cadastro de Tipo de Operao de Operador Logstico */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela TIPOOPEROPL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela TIPOOPEROPL,
             utilizando a tabela Geral de Logs de Operaes */
CREATE OR REPLACE TRIGGER LOG_DFS_TIPOOPEROPL
AFTER DELETE OR INSERT OR UPDATE ON TIPOOPEROPL FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(500);
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDFILIOPELOG IS NOT NULL THEN
         V_DESC := V_DESC || 'OL=' || :OLD.CDFILIOPELOG;
      END IF;

      IF :OLD.CDFILDEST IS NOT NULL THEN
         V_DESC := V_DESC || ' Filial Dest.=' || :OLD.CDFILDEST;
      END IF;

      IF :OLD.CDTIPOOPERSAID IS NOT NULL THEN
         V_DESC := V_DESC || ' Saida OL=' || :OLD.CDTIPOOPERSAID;
      END IF;

      IF :OLD.IDTIPOOPERSAID IS NOT NULL THEN
         V_DESC := V_DESC || ' Id Saida Ol=' || :OLD.IDTIPOOPERSAID;
      END IF;

      IF :OLD.CDTIPOOPERENTR IS NOT NULL THEN
         V_DESC := V_DESC || ' Entr. OL=' || :OLD.CDTIPOOPERENTR;
      END IF;

      IF :OLD.IDTIPOOPERENTR IS NOT NULL THEN
         V_DESC := V_DESC || ' Id Entr. OL=' || :OLD.IDTIPOOPERENTR;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIOPELOG||:OLD.CDFILDEST;

   ELSE
      IF UPDATING THEN
         IF (:OLD.CDFILIOPELOG     <> :NEW.CDFILIOPELOG)     OR
            (:OLD.CDFILDEST        <> :NEW.CDFILDEST)        OR
            (NVL(:OLD.IDTIPOOPERSAID,'!')   <> NVL(:NEW.IDTIPOOPERSAID,'!'))   OR
            (NVL(:OLD.IDTIPOOPERENTR,'!')   <> NVL(:NEW.IDTIPOOPERENTR,'!'))   OR
            (NVL(:OLD.CDTIPOOPERSAID,'!')   <> NVL(:NEW.CDTIPOOPERSAID,'!'))   OR
            (NVL(:OLD.CDTIPOOPERENTR,'!')   <> NVL(:NEW.CDTIPOOPERENTR,'!'))   THEN

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDFILIOPELOG||:OLD.CDFILDEST;

         END IF;
      ELSE
         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDFILIOPELOG||:NEW.CDFILIOPELOG;

      END IF;

      IF NVL(:NEW.CDFILIOPELOG, '!') <> NVL(:OLD.CDFILIOPELOG, '!') THEN
         V_DESC := V_DESC || 'OL=' || :NEW.CDFILIOPELOG;
      END IF;

      IF NVL(:NEW.CDFILDEST, '!') <> NVL(:OLD.CDFILDEST, '!') THEN
         V_DESC := V_DESC || ' Filial Dest.=' || :NEW.CDFILDEST;
      END IF;

      IF NVL(:NEW.IDTIPOOPERSAID, '!') <> NVL(:OLD.IDTIPOOPERSAID, '!') THEN
         V_DESC := V_DESC || ' Id Saida Ol=' || :NEW.IDTIPOOPERSAID;
      END IF;

      IF NVL(:NEW.IDTIPOOPERENTR, '!') <> NVL(:OLD.IDTIPOOPERENTR, '!') THEN
         V_DESC := V_DESC || ' Id Entr. OL=' || :NEW.IDTIPOOPERENTR;
      END IF;

      IF NVL(:NEW.CDTIPOOPERSAID, '!') <> NVL(:OLD.CDTIPOOPERSAID, '!') THEN
         V_DESC := V_DESC || ' Saida OL=' || :NEW.CDTIPOOPERSAID;
      END IF;

      IF NVL(:NEW.CDTIPOOPERENTR, '!') <> NVL(:OLD.CDTIPOOPERENTR, '!') THEN
         V_DESC := V_DESC || ' Entr. OL=' || :NEW.CDTIPOOPERENTR;
      END IF;

   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);
      V_DTOPER := SYSDATE;

      INSERT INTO LOGOPERA
         (NMTABELA,
          DTOPERACAO,
          NMRESPOPER,
          IDTIPOOPER,
          CDPESQITEM,
          DSOPERACAO,
          DSRDMUSUOPER,
          DSENDUSUOPER,
          DSNMUSUOPER,
          DSMETUSUOPER,
          CDORESPOPER)
      VALUES
         ('TIPOOPEROPL',
          V_DTOPER,
          V_USUARIO,
          V_TIPO,
          V_ITPESQ,
          SUBSTR(V_DESC,1,300),
          V_DSSERVERRDM,
          V_DSREMOTEADDR,
          V_DSREMOTEHOST,
          V_DSSERVMETHOD,
          V_DSREMOTEOPER);
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_DFS_TIPOOPEROPL','5.33.000'); END;
/

